## syslinux 6.04~git20190206.bf6db5b4+dfsg1

=== core/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 1998-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009-2016 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# Makefile for the SYSLINUX core
#

VPATH = $(SRC)

# No builtin rules
MAKEFLAGS += -r
MAKE      += -r

include $(MAKEDIR)/embedded.mk
-include $(objdir)/version.mk

OPTFLAGS =
INCLUDES = -I$(SRC)/include -I$(com32)/include -I$(com32)/include/sys -I$(com32)/lib \
	-I$(SRC)/lwip/src/include -I$(SRC)/lwip/src/include/ipv4 -I$(SRC)/fs/pxe

# This is very similar to cp437; technically it's for Norway and Denmark,
# but it's unlikely the characters that are different will be used in
# filenames by other users.
CODEPAGE = cp865

# The targets to build in this directory...
BTARGET  = kwdhash.gen \
	   ldlinux.bss ldlinux.sys ldlinux.bin \
	   isolinux.bin isolinux-debug.bin pxelinux.0 lpxelinux.0

# All primary source files for the main syslinux files
NASMSRC	 := $(sort $(wildcard $(SRC)/*.asm))
NASMHDR  := $(sort $(wildcard $(SRC)/*.inc))
CSRC	 := $(sort $(shell find $(SRC) -name '*.c' -print))
SSRC	 := $(sort $(shell find $(SRC) -name '*.S' -print))
CHDR	 := $(sort $(shell find $(SRC) -name '*.h' -print))
OTHERSRC := keywords
ALLSRC    = $(NASMSRC) $(NASMHDR) $(CSRC) $(SSRC) $(CHDR) $(OTHERSRC)

COBJ	 := $(subst $(SRC)/,,$(patsubst %.c,%.o,$(CSRC)))
SOBJ	 := $(subst $(SRC)/,,$(patsubst %.S,%.o,$(SSRC)))

# To make this compatible with the following $(filter-out), make sure
# we prefix everything with $(SRC)
CORE_PXE_CSRC = \
	$(addprefix $(SRC)/fs/pxe/, dhcp_option.c pxe.c tftp.c urlparse.c bios.c)

LPXELINUX_CSRC = $(CORE_PXE_CSRC) \
	$(sort $(shell find $(SRC)/lwip -name '*.c' -print)) \
	$(addprefix $(SRC)/fs/pxe/, \
		core.c dnsresolv.c ftp.c ftp_readdir.c gpxeurl.c http.c \
		http_readdir.c idle.c isr.c tcp.c)

PXELINUX_CSRC = $(CORE_PXE_CSRC) \
	$(sort $(shell find $(SRC)/legacynet -name '*.c' -print))

LPXELINUX_OBJS = $(subst $(SRC)/,,$(LPXELINUX_CSRC:%.c=%.o))
PXELINUX_OBJS  = $(subst $(SRC)/,,$(PXELINUX_CSRC:%.c=%.o))

UNITTEST_CSRC = $(shell find $(SRC) -path '*/tests/*.c' -print)
UNITTEST_OBJS = $(subst $(SRC)/,,$(UNITTEST_CSRC:%.c=%.o))

# Don't include console and network stack specific objects or unit tests
FILTER_OBJS = %rawcon.o %plaincon.o %pxelinux-c.o %ldlinux-c.o \
	%isolinux-c.o %localboot.o %pxeboot.o \
	$(subst $(OBJ)/,,$(UNITTEST_OBJS)) \
	$(subst $(OBJ)/,,$(LPXELINUX_OBJS)) \
	$(subst $(OBJ)/,,$(PXELINUX_OBJS))

ifeq ($(FWCLASS),EFI)
# EFI is single-threaded, and doesn't use the LZO assembly decoder
FILTER_OBJS += $(subst $(SRC)/,, \
	$(patsubst %.S,%.o, $(sort $(wildcard $(SRC)/lzo/*.S))) \
	$(patsubst %.c,%.o, $(sort $(wildcard $(SRC)/thread/*.c))) \
	$(patsubst %.S,%.o, $(sort $(wildcard $(SRC)/thread/*.S)))) \
	$(patsubst %.asm,%.o, $(sort $(wildcard $(SRC)/*.asm))) \
	$(patsubst %.c,%.o, $(sort $(wildcard $(SRC)/bios*.c)))
endif

COBJS	 = $(filter-out $(FILTER_OBJS),$(COBJ))
SOBJS	 = $(filter-out $(FILTER_OBJS),$(SOBJ))

ifeq ($(FWCLASS),EFI)
COBJS += $(subst $(SRC)/,,$(CORE_PXE_CSRC:%.c=%.o) fs/pxe/ftp.o fs/pxe/ftp_readdir.o \
	fs/pxe/http.o fs/pxe/http_readdir.o)
endif

LIB	 = libcom32.a
LIBS	 = $(LIB) --whole-archive $(objdir)/com32/lib/libcom32core.a
LIBDEP   = $(filter-out -% %start%,$(LIBS))
LIBOBJS	 = $(COBJS) $(SOBJS)

NASMDEBUG = -g -F dwarf
NASMOPT  += $(NASMDEBUG)

PREPCORE = $(OBJ)/../lzo/prepcore

CFLAGS += -D__SYSLINUX_CORE__ -D__FIRMWARE_$(FIRMWARE)__ \
	  -I$(objdir) -DLDLINUX=\"$(LDLINUX)\"

# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(SRC)/../now.pl $(SRCS))
endif
ifndef DATE
DATE    := $(shell sh $(SRC)/../gen-id.sh $(VERSION) $(HEXDATE))
endif

ifeq ($(FWCLASS),EFI)
all: makeoutputdirs $(filter-out %bios.o,$(COBJS) $(SOBJS)) codepage.o
else
all: makeoutputdirs $(BTARGET)
endif

makeoutputdirs:
	@mkdir -p $(sort $(dir $(COBJ) $(SOBJ)))

kwdhash.gen: keywords genhash.pl
	$(PERL) $(SRC)/genhash.pl < $(SRC)/keywords > $(OBJ)/kwdhash.gen

ifeq ($(FWCLASS),BIOS)

.PRECIOUS: %.elf
%.raw: %.elf
	$(OBJCOPY) -O binary -S $< $(@:.bin=.raw)

# GNU make 3.82 gets confused by plain %.raw; make 4.0 requires it
.PRECIOUS: $(OBJ)/%.raw %.raw
%.bin: %.raw $(PREPCORE)
	$(PREPCORE) $< $@

%.o: %.asm kwdhash.gen $(OBJ)/../version.gen
	$(NASM) -f $(NASM_ELF) $(NASMOPT) -DDATE_STR="'$(DATE)'" \
		-DHEXDATE="$(HEXDATE)" \
		-D$(ARCH) \
		-I$(SRC)/ \
		-l $(@:.o=.lsr) -o $@ -MP -MD $(dir $@).$(notdir $@).d $<

AUXLIBS = libisolinux.a libisolinux-debug.a libldlinux.a \
	libpxelinux.a liblpxelinux.a

LDSCRIPT = $(SRC)/$(ARCH)/syslinux.ld

NASM_ELF = elf

%.elf: %.o $(LIBDEP) $(LDSCRIPT) $(AUXLIBS)
	$(LD) $(LDFLAGS) -pie -Bsymbolic \
		-T $(LDSCRIPT) \
		--unresolved-symbols=report-all \
		-E --hash-style=gnu -M -o $@ $< \
		--start-group $(LIBS) $(subst $(*F).elf,lib$(*F).a,$@) --end-group \
		> $(@:.elf=.map)
	if [ `$(NM) -D -u $@ | wc -l` -ne 0 ]; then \
		$(NM) -D -u $@ 1>&2; rm -f $@; false; fi
	$(OBJDUMP) -h $@ > $(@:.elf=.sec)
	$(PERL) $(SRC)/lstadjust.pl $(@:.elf=.lsr) $(@:.elf=.sec) $(@:.elf=.lst)

libisolinux.a: rawcon.o localboot.o isolinux-c.o
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

libisolinux-debug.a: libisolinux.a
	cp $^ $@

# Legacy network stack
libpxelinux.a: rawcon.o pxeboot.o pxelinux-c.o $(PXELINUX_OBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

# LwIP network stack
liblpxelinux.a: rawcon.o pxeboot.o pxelinux-c.o $(LPXELINUX_OBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

libldlinux.a: plaincon.o localboot.o ldlinux-c.o
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

pxelinux.o: pxelinux.asm kwdhash.gen ../version.gen
	$(NASM) -f $(NASM_ELF) $(NASMOPT) -DDATE_STR="'$(DATE)'" \
		-DHEXDATE="$(HEXDATE)" \
		-D$(ARCH) \
		-I$(SRC)/ \
		-DIS_LPXELINUX=0 \
		-l $(@:.o=.lsr) -o $@ -MP -MD $(dir $@).$(notdir $@).d $<

pxelinux.0: pxelinux.bin
	cp -f $< $@

lpxelinux.o: pxelinux.asm kwdhash.gen ../version.gen
	$(NASM) -f $(NASM_ELF) $(NASMOPT) -DDATE_STR="'$(DATE)'" \
		-DHEXDATE="$(HEXDATE)" \
		-D$(ARCH) \
		-I$(SRC)/ \
		-DIS_LPXELINUX=1 \
		-l $(@:.o=.lsr) -o $@ -MP -MD $(dir $@).$(notdir $@).d $<

lpxelinux.0: lpxelinux.bin
	cp -f $< $@

ldlinux.bss: ldlinux.bin
	dd if=$< of=$@ bs=512 count=1

ldlinux.sys: ldlinux.bin
	dd if=$< of=$@ bs=512 skip=2

endif # BIOS

$(LIB): $(LIBOBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

codepage.cp: $(OBJ)/../codepage/$(CODEPAGE).cp
	cp -f $< $@

codepage.o: codepage.S codepage.cp

install: installer

install-lib: installer

install-all: install install-lib

netinstall: installer

tidy dist:
	find . -type f \( -name '*.o' -o -name '*.a' -o -name '.*.d' \
		-o -name '*.lst' \) -print | xargs -rt rm -f
	rm -f codepage.cp *.elf stupid.* patch.offset .depend
	rm -f *.elf.tmp *.sym
	rm -f *.lsr *.map *.sec *.raw
	rm -f $(OBSOLETE) $(LIB)

clean: tidy

spotless: clean
	rm -f $(BTARGET) *.bin *_bin.c

# Include dependencies file
-include $(shell find . -name '.*.d' -print)

=== efi/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2011 Intel Corporation; author: Matt Fleming
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

VPATH = $(SRC)
include $(MAKEDIR)/lib.mk
include $(MAKEDIR)/efi.mk

CC_FOR_BUILD ?= $(CC)

# Upstream gnu-efi has old-style function definitions.
CFLAGS += -Wno-strict-prototypes

CORE_CSRC := $(sort $(wildcard $(core)/*.c $(core)/*/*.c $(core)/*/*/*.c))
CORE_COBJ := $(subst $(core),$(OBJ)/../core,$(patsubst %.c,%.o,$(CORE_CSRC)))

# We don't want to include any of the networking stack or the thread
# code since it will be implemented completely differently for EFI.
FILTERED_OBJS:= $(sort $(subst $(core),$(OBJ)/../core,$(patsubst %.c,%.o, \
	$(wildcard $(core)/legacynet/*.c) \
	$(wildcard $(core)/fs/pxe/*.c) \
	$(wildcard $(core)/thread/*.c))))

# Don't include unit tests
FILTERED_OBJS += $(subst $(core),$(OBJ)/../core, \
	$(patsubst %.c,%.o,$(shell find $(core) -path "*/tests/*.c" -print)))

# Don't include console objects
CORE_OBJS = $(filter-out %hello.o %rawcon.o %plaincon.o %strcasecmp.o %bios.o \
	%diskio_bios.o %ldlinux-c.o %isolinux-c.o %pxelinux-c.o \
	%localboot.o %pxeboot.o \
	$(FILTERED_OBJS),$(CORE_COBJ) $(CORE_SOBJ))

CORE_OBJS += $(addprefix $(OBJ)/../core/, \
	fs/pxe/pxe.o fs/pxe/tftp.o fs/pxe/urlparse.o fs/pxe/dhcp_option.o \
	fs/pxe/ftp.o fs/pxe/ftp_readdir.o fs/pxe/http.o fs/pxe/http_readdir.o)

LIB_OBJS = $(addprefix $(objdir)/com32/lib/,$(CORELIBOBJS)) \
	$(LIBEFI)

CSRC = $(sort $(wildcard $(SRC)/*.c))
OBJS = $(subst $(SRC)/,,$(filter-out %wrapper.o, $(patsubst %.c,%.o,$(CSRC))))

OBJS += $(objdir)/core/codepage.o $(ARCH)/linux.o

# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(SRC)/../now.pl $(SRCS))
endif
ifndef DATE
DATE    := $(shell sh $(SRC)/../gen-id.sh $(VERSION) $(HEXDATE))
endif
CFLAGS		+= -DDATE_STR='"$(DATE)"'

$(OBJ)/$(ARCH):
	mkdir -p $@

$(OBJS): | $(OBJ)/$(ARCH)

# The targets to build in this directory
BTARGET  = syslinux.efi

syslinux.so: $(OBJS) $(CORE_OBJS) $(LIB_OBJS)
	$(LD) $(LDFLAGS) --strip-debug -o $@ $^ -lgnuefi -lefi

# We need to rename the .hash section because the EFI firmware
# linker really doesn't like it.
# $(OBJCOPY) --rename-section .gnu.hash=.sdata,load,data,alloc $^ $@
#syslinux.so: syslinux1.so
#	cp $^ $@

wrapper: wrapper.c
	$(CC_FOR_BUILD) $^ -o $@

#
# Build the wrapper app and wrap our .so to produce a .efi
syslinux.efi: syslinux.so wrapper
	$(OBJ)/wrapper syslinux.so $@

all: $(BTARGET)

codepage.o: ../codepage/cp865.cp
	cp $(objdir)/../codepage/cp865.cp codepage.cp
	$(CC) $(SFLAGS) -c -o $@ $(core)/codepage.S

install:
	install -m 755 $(BTARGET) $(INSTALLROOT)$(AUXDIR)

strip:

tidy dist:
	rm -f *.so *.o wrapper
	find . \( -name \*.o -o -name \*.a -o -name .\*.d -o -name \*.tmp \) -print0 | \
		xargs -0r rm -f
	$(topdir)/efi/clean-gnu-efi.sh $(EFI_SUBARCH) $(objdir)

clean: tidy

spotless: clean
	rm -f $(BTARGET)

=== extlinux/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## Linux vfat, ntfs, ext2/ext3/ext4 and btrfs installer
##

include $(MAKEDIR)/syslinux.mk

OPTFLAGS = -g -Os
INCLUDES = -I$(SRC) -I$(objdir) -I$(SRC)/../libinstaller
CFLAGS	 = $(GCCWARN) -Wno-sign-compare -D_FILE_OFFSET_BITS=64 \
	   $(OPTFLAGS) $(INCLUDES)
LDFLAGS	 = 

SRCS     = main.c \
	   mountinfo.c \
	   ../libinstaller/syslxmod.c \
	   ../libinstaller/syslxopt.c \
	   ../libinstaller/syslxcom.c \
	   ../libinstaller/syslxrw.c \
	   ../libinstaller/setadv.c \
	   ../libinstaller/advio.c \
	   ../libinstaller/bootsect_bin.c \
	   ../libinstaller/ldlinuxc32_bin.c \
	   ../libinstaller/ldlinux_bin.c
OBJS	 = $(patsubst %.c,%.o,$(notdir $(SRCS)))

.SUFFIXES: .c .o .i .s .S

VPATH = $(SRC):$(SRC)/../libinstaller:$(OBJ)/../libinstaller

all: installer

tidy dist:
	-rm -f *.o *.i *.s *.a .*.d *.tmp

clean: tidy
	-rm -f extlinux

spotless: clean
	-rm -f *~

installer: extlinux

extlinux: $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^

strip:
	$(STRIP) extlinux

%.o: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -c -o $@ $<
%.i: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -E -o $@ $<
%.s: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -S -o $@ $<

-include .*.d

=== linux/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## Linux FAT/NTFS installer
##

include $(MAKEDIR)/syslinux.mk

OPTFLAGS = -g -Os
INCLUDES = -I$(SRC) -I$(objdir) -I$(SRC)/../libinstaller
CFLAGS	 = $(GCCWARN) -D_FILE_OFFSET_BITS=64 $(OPTFLAGS) $(INCLUDES)
LDFLAGS	 = 

SRCS     = syslinux.c \
	   ../libinstaller/syslxopt.c \
	   ../libinstaller/syslxrw.c \
	   ../libinstaller/syslxcom.c \
	   ../libinstaller/setadv.c \
	   ../libinstaller/advio.c \
           ../libinstaller/fs.c \
           ../libinstaller/syslxmod.c \
	   ../libinstaller/bootsect_bin.c \
	   ../libinstaller/ldlinuxc32_bin.c \
	   ../libinstaller/ldlinux_bin.c
OBJS	 = $(patsubst %.c,%.o,$(notdir $(SRCS)))

.SUFFIXES: .c .o .i .s .S

VPATH = $(SRC):$(SRC)/../libinstaller:$(OBJ)/../libinstaller

all: installer

tidy dist:
	-rm -f *.o *.i *.s *.a .*.d *.tmp

clean: tidy
	-rm -f syslinux syslinux-nomtools

spotless: clean
	-rm -f *~

installer: syslinux syslinux-nomtools

syslinux: $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^

syslinux-nomtools: syslinux
	ln -f $< $@

strip:
	$(STRIP) syslinux syslinux-nomtools

%.o: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -c -o $@ $<
%.i: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -E -o $@ $<
%.s: %.c
	$(CC) $(UMAKEDEPS) $(CFLAGS) -S -o $@ $<

-include .*.d

=== utils/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 1998-2008 H. Peter Anvin - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# SYSLINUX utilities
#

VPATH = $(SRC)
include $(MAKEDIR)/syslinux.mk

CC_FOR_BUILD ?= $(CC)

CFLAGS   = $(CFLAGS_FOR_BUILD) $(GCCWARN) -Os -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 -I$(SRC)
LDFLAGS  = $(LDFLAGS_FOR_BUILD) -O2

C_TARGETS	 = isohybrid gethostip memdiskfind
SCRIPT_TARGETS	 = mkdiskimage
SCRIPT_TARGETS	+= isohybrid.pl  # about to be obsoleted
ASIS		 = $(addprefix $(SRC)/,keytab-lilo lss16toppm md5pass \
		   ppmtolss16 sha1pass syslinux2ansi pxelinux-options)

TARGETS = $(C_TARGETS) $(SCRIPT_TARGETS)

ISOHDPFX = $(addprefix $(OBJ)/,../mbr/isohdpfx.bin ../mbr/isohdpfx_f.bin \
	   ../mbr/isohdpfx_c.bin \
	   ../mbr/isohdppx.bin ../mbr/isohdppx_f.bin ../mbr/isohdppx_c.bin)

all: $(TARGETS)

%.o: %.c
	$(CC_FOR_BUILD) $(UMAKEDEPS) $(CFLAGS) -c -o $@ $<

mkdiskimage: mkdiskimage.in ../mbr/mbr.bin bin2hex.pl
	$(PERL) $(SRC)/bin2hex.pl < $(OBJ)/../mbr/mbr.bin | cat $(SRC)/mkdiskimage.in - > $@
	chmod a+x $@

# Works on anything with a Perl interpreter...
isohybrid.pl: isohybrid.in $(ISOHDPFX) bin2hex.pl
	cp -f $(SRC)/isohybrid.in $@
	for f in $(ISOHDPFX) ; do $(PERL) $(SRC)/bin2hex.pl < $$f >> $@ ; done
	chmod a+x $@

isohdpfx.c: $(ISOHDPFX) isohdpfxarray.pl
	$(PERL) $(SRC)/isohdpfxarray.pl $(ISOHDPFX) > $@

isohybrid: isohybrid.o isohdpfx.o
	$(CC_FOR_BUILD) $(LDFLAGS) -o $@ $^ -luuid

gethostip: gethostip.o
	$(CC_FOR_BUILD) $(LDFLAGS) -o $@ $^

memdiskfind: memdiskfind.o
	$(CC_FOR_BUILD) $(LDFLAGS) -o $@ $^

tidy dist:
	rm -f *.o .*.d isohdpfx.c

clean: tidy
	rm -f $(TARGETS)

spotless: clean

installer: all

install: installer
	mkdir -m 755 -p $(INSTALLROOT)$(BINDIR)
	install -m 755 $(TARGETS) $(ASIS) $(INSTALLROOT)$(BINDIR)

strip:
	$(STRIP) $(C_TARGETS)

-include .*.d

=== com32/cmenu/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## Makefile for the complex menu system
##

NOGPL := 1

LIBS  = libmenu/libmenu.c32 \
        $(objdir)/com32/libutil/libutil.c32 \
        $(objdir)/com32/lib/libcom32.c32

C_LIBS	  = libmenu/libmenu.c32

VPATH = $(SRC)
include $(MAKEDIR)/elf.mk

CFLAGS	  += -I$(SRC)/libmenu

LIBMENU = libmenu/syslnx.o libmenu/com32io.o libmenu/tui.o \
	libmenu/menu.o libmenu/passwords.o libmenu/des.o libmenu/help.o \
	$(objdir)/com32/libutil/libutil.c32 $(objdir)/com32/lib/libcom32.c32

CMENUS = $(patsubst %.c,%.c32,$(sort $(wildcard $(SRC)/*.c)))
IMENUS = $(patsubst %.menu,%.c32,$(sort $(wildcard $(SRC)/*.menu)))

MENUS = $(LIBS) $(subst $(SRC)/,,$(CMENUS) $(IMENUS))

.SUFFIXES: .S .c .o .elf .c32 .menu

.PRECIOUS: %.c
%.c: %.menu adv_menu.tpl
	$(PYTHON) $(SRC)/menugen.py --input=$< --output=$@ --template=$(SRC)/adv_menu.tpl

all:	makeoutputdirs menus

makeoutputdirs:
	@mkdir -p $(OBJ)/libmenu

libmenu/libmenu.elf: $(LIBMENU)
	$(LD) -shared $(LDFLAGS) -soname $(patsubst %.elf,%.c32,$(@F)) \
		-o $@ $^

tidy dist:
	rm -f *.o *.lo *.lst *.elf */*.o */*.elf .*.d */.*.d

libclean:
	rm -f libmenu/*.c32

clean: tidy menuclean
	rm -f *.lss *.com

menuclean:
	rm -f $(patsubst %.menu,%.c,$(sort $(wildcard *.menu)))

spotless: clean libclean menuclean
	rm -f *~ \#* *.c32

menus: $(MENUS)

install:	# Don't install samples

-include .*.d */.*.d

=== com32/lib/Makefile ===
#
# ONLY INCLUDE MIT OR 2/3-BSD-LICENSED CODE IN THIS LIBRARY
#

# Include configuration rules
NOGPL := 1
VPATH = $(SRC)
include $(MAKEDIR)/lib.mk

## OPTIONAL OBJECTS, AVAILABLE AS DYNAMIC LINKED MODULES
# PNG library object files
LIBPNG_OBJS = \
	libpng/png.o libpng/pngset.o libpng/pngget.o libpng/pngrutil.o  \
	libpng/pngtrans.o libpng/pngwutil.o libpng/pngread.o		\
	libpng/pngrio.o libpng/pngwio.o libpng/pngwrite.o		\
	libpng/pngrtran.o libpng/pngwtran.o libpng/pngmem.o		\
	libpng/pngerror.o libpng/pngpread.o

# JPG library object files
LIBJPG_OBJS = \
	jpeg/tinyjpeg.o jpeg/jidctflt.o	jpeg/decode1.o jpeg/decode3.o   \
	jpeg/rgb24.o jpeg/bgr24.o jpeg/yuv420p.o jpeg/grey.o		\
	jpeg/rgba32.o jpeg/bgra32.o					

ifeq ($(FWCLASS),EFI)
I915VESA_OBJ =
else
I915VESA_OBJ = sys/vesa/i915resolution.o
endif

LIBVESA_OBJS = \
	sys/vesacon_write.o sys/vesaserial_write.o			\
	sys/vesa/initvesa.o sys/vesa/drawtxt.o	sys/vesa/background.o	\
	sys/vesa/alphatbl.o sys/vesa/screencpy.o sys/vesa/fmtpixel.o	\
	$(I915VESA_OBJ)

LIBMISC_OBJS = \
	sys/libansi.o sys/gpxe.o

LIBPCI_OBJS = \
	pci/cfgtype.o pci/scan.o pci/bios.o				\
	pci/readb.o pci/readw.o pci/readl.o				\
	pci/writeb.o pci/writew.o pci/writel.o

LIBSYSLINUX_OBJS = \
	syslinux/reboot.o syslinux/keyboard.o				\
	syslinux/version.o						\
	syslinux/pxe_get_cached.o syslinux/pxe_get_nic.o		\
	syslinux/video/fontquery.o syslinux/video/reportmode.o

DYNENTRY_OBJS = \
	atexit.o onexit.o abort.o

MINLIBOBJS = \
	syslinux/ipappend.o \
	syslinux/dsinfo.o \
	$(LIBOTHER_OBJS) \
	$(LIBGCC_OBJS) \
	$(LIBCONSOLE_OBJS) \
	$(LIBLOAD_OBJS) \
	$(LIBZLIB_OBJS)
#	$(LIBVESA_OBJS)

DYNLIBOBJS = \
	$(LIBZLIB_OBJS) \
	$(LIBPNG_OBJS) \
	$(LIBJPG_OBJS) \
	$(LIBPCI_OBJS) \
	$(LIBVESA_OBJS) \
	$(LIBSYSLINUX_OBJS) \
	$(LIBLOAD_OBJS) \
	$(LIBMISC_OBJS) \
	$(DYNENTRY_OBJS)


LIBOBJS = $(DYNLIBOBJS)

BINDIR   = /usr/bin
LIBDIR   = /usr/lib
DATADIR  = /usr/share
AUXDIR   = $(DATADIR)/syslinux
INCDIR   = /usr/include
COM32DIR = $(AUXDIR)/com32

all: makeoutputdirs libcom32.c32 libcom32min.a libcom32core.a

makeoutputdirs:
	@mkdir -p $(foreach b, \
		$(addprefix $(OBJ)/,$(sort $(dir $(LIBOBJS) $(MINLIBOBJS) $(CORELIBOBJS)))),$(b))

libcom32.elf : $(LIBOBJS)
	rm -f $@
	$(LD) -shared $(LDFLAGS) -soname $(patsubst %.elf,%.c32,$(@F)) -o $@ $^

libcom32min.a : $(MINLIBOBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

libcom32core.a : $(CORELIBOBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

tidy dist clean:
	rm -f sys/vesa/alphatbl.c errlist.c
	find . \( -name \*.o -o -name \*.a -o -name .\*.d -o -name \*.tmp \) -print0 | \
		xargs -0r rm -f

spotless: clean
	rm -f *.a *.c32
	rm -f *~ \#* */*~ */\#*

install: all
	mkdir -m 755 -p $(INSTALLROOT)$(COM32DIR)
	-rm -rf $(INSTALLROOT)$(COM32DIR)/include
	cp -r $(SRC)/../include $(INSTALLROOT)$(COM32DIR)

errlist.c: makeerrlist.pl $(SRC)/../include/errno.h
	$(PERL) $<  $(CFLAGS) -errlist > $@ || rm -f $@

# These files are performance critical, and doesn't compile well with -Os
sys/vesa/drawtxt.o: sys/vesa/drawtxt.c
	$(CC) $(MAKEDEPS) $(CFLAGS) -O3 -c -o $@ $<

sys/vesa/alphatbl.c: sys/vesa/alphatbl.pl
	$(PERL) $< > $@

jpeg/jidctflt.o: jpeg/jidctflt.c
	$(CC) $(MAKEDEPS) $(CFLAGS) -O3 -c -o $@ $<

-include .*.d */.*.d */*/.*.d

=== com32/rosh/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##   Copyright 2010 Intel Corporation; author: H. Peter Anvin
##   Copyright 2008-2010 Gene Cumm - All Rights Reserved
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## ROSH Read Only Shell
##

LIBS = $(objdir)/com32/libutil/libutil.c32 \
	$(objdir)/com32/lib/libcom32.c32

VPATH = $(SRC)
include $(MAKEDIR)/rosh.mk

# from com32/sysdump/Makefile
# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(topdir)/now.pl $(SRCS) $(sort $(wildcard *.h)))
endif
ifndef DATE
DATE    := $(shell sh $(topdir)/gen-id.sh $(VERSION) $(HEXDATE))
endif

CFLAGS		+= -DDATE='"$(DATE)"'
LNXCFLAGS	+= -DDATE='"$(DATE)"'

all:	rosh.c32

rosh.o:	rosh.h

rosh.lo:	rosh.h

allgrc:	rosh.c32 rosh.lnx

tidy dist:
	rm -f *.o *.lo *.a *.lst *.elf .*.d *.tmp

clean: tidy
	rm -f *.lnx

spotless: clean
	rm -f *.lss *.c32 *.com
	rm -f *~ \#*

install:

-include .*.d

=== com32/sysdump/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2001-2008 H. Peter Anvin - All Rights Reserved
##   Copyright 2010 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
##   Boston MA 02110-1301, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

##
## Simple menu system
##

VPATH = $(SRC)
include $(MAKEDIR)/elf.mk
-include $(topdir)/version.mk

LIBS	   = $(objdir)/com32/libupload/libcom32upload.a
LNXLIBS	   = $(objdir)/com32/libutil/libutil_lnx.a

CFLAGS += -I$(com32) -I$(topdir)

MODULES	  = sysdump.c32
TESTFILES =

SRCS = $(sort $(wildcard $(SRC)/*.c))
OBJS = $(subst $(SRC)/,,$(patsubst %.c,%.o,$(SRCS)))

# The DATE is set on the make command line when building binaries for
# official release.  Otherwise, substitute a hex string that is pretty much
# guaranteed to be unique to be unique from build to build.
ifndef HEXDATE
HEXDATE := $(shell $(PERL) $(topdir)/now.pl $(SRCS) $(sort $(wildcard *.h)))
endif
ifndef DATE
DATE    := $(shell sh $(topdir)/gen-id.sh $(VERSION) $(HEXDATE))
endif

CFLAGS    += -DDATE='"$(DATE)"'

all: $(MODULES) $(TESTFILES)

sysdump.elf : $(OBJS) $(LIBS) $(C_LIBS)
	$(LD) $(LDFLAGS) -o $@ $^

tidy dist:
	rm -f *.o *.lo *.a *.lst .*.d *.tmp

clean: tidy
	rm -f *.lnx

spotless: clean
	rm -f *.lss *.c32 *.com
	rm -f *~ \#*

install:

-include .*.d

=== diag/geodsp/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 2010-2015 Gene Cumm
##
##   Portions from core/Makefile:
##   Copyright 1998-2009 H. Peter Anvin - All Rights Reserved
##   Copyright 2009-2010 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# Makefile for the SYSLINUX geometry display for diagnostics
#

include $(MAKEDIR)/embedded.mk
coredir = $(topdir)/core
VPATH = $(SRC)

BTARGET = geodsp1s.bin geodsp1s_f.bin geodspms.bin \
	geodsp1s.img.xz geodspms.img.xz

NASMOPT = -i $(coredir)/ -i $(SRC)/ -Ox -f bin -dBINFMT
NASMOPT += -w+orphan-labels
CFLAGS = -g -O
LIBS = $(coredir)/writehex.inc $(coredir)/macros.inc $(coredir)/diskboot.inc geodsplib.inc

all: $(BTARGET)

# Higher compression levels result in larger files
%.img.xz: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< | $(XZ) -0 > $@ || ( rm -f $@ ; false )

%.img.gz: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< | $(GZIPPROG) -9 > $@ || ( rm -f $@ ; false )

# in case someone really wants these without needing a decompressor
%.img: %.bin mk-lba-img.pl
	$(PERL) $(SRC)/mk-lba-img.pl $< > $@ || ( rm -f $@ ; false )

%.bin: %.asm $(LIBS)
	$(NASM) $(NASMOPT) -o $@ -l $(@:.bin=.lst) $<

%_f.bin: %.asm $(LIBS)
	$(NASM) $(NASMOPT) -o $@ -dFORCE_80 -l $(@:.bin=.lst) $<

mk-lba-img: mk-lba-img.c
	$(CC) $(CFLAGS) -o $@ $<

tidy dist:
	rm -Rf *.lst *.img
	rm -f mk-lba-img

clean: tidy

spotless: clean
	rm -f $(BTARGET)

=== win64/ntfstest/Makefile ===
## -----------------------------------------------------------------------
##
##   Copyright 1998-2008 H. Peter Anvin - All Rights Reserved
##   Copyright 2010 Intel Corporation; author: H. Peter Anvin
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, Inc., 53 Temple Place Ste 330,
##   Boston MA 02111-1307, USA; either version 2 of the License, or
##   (at your option) any later version; incorporated herein by reference.
##
## -----------------------------------------------------------------------

#
# Makefile for Win64 NTFS file cluster test
#
# This is separated out mostly so we can have a different set of Makefile
# variables.
#

OSTYPE   = $(shell uname -msr)
# Don't know how to do a native compile here...
WINPREFIX  := $(shell ../find-mingw64.sh gcc)
WINCFLAGS  := $(GCCWARN) -Wno-sign-compare -Os -fomit-frame-pointer \
	      -D_FILE_OFFSET_BITS=64
WINLDFLAGS := -Os -s
WINCFLAGS += -I. -I../../win

WINCC      := $(WINPREFIX)gcc
WINAR	   := $(WINPREFIX)ar
WINRANLIB  := $(WINPREFIX)ranlib
WINDRES    := $(WINPREFIX)windres

WINCC_IS_GOOD := $(shell $(WINCC) $(WINCFLAGS) $(WINLDFLAGS) \
	-o hello.exe ../../win/hello.c >/dev/null 2>&1 ; echo $$?)

.SUFFIXES: .c .obj .lib .exe .i .s .S .rc .res

SRCS     = ../../win/ntfstest.c ../../win/ntfssect.c
RCS      = ../../win/ntfstest.rc
OBJS     = $(patsubst %.c,%.obj,$(notdir $(SRCS)))
RESS     = $(patsubst %.rc,%.res,$(notdir $(RCS)))

VPATH = .:../../win

TARGETS = ntfstest64.exe

ifeq ($(WINCC_IS_GOOD),0)
all: $(TARGETS)
else
all:
	rm -f $(TARGETS)
endif

tidy dist:
	-rm -f *.o *.obj *.lib *.i *.s *.a .*.d *.tmp *_bin.c hello.exe

clean: tidy

spotless: clean
	-rm -f *~ $(TARGETS)

ntfstest64.exe: $(OBJS) $(RESS)
	$(WINCC) $(WINLDFLAGS) -o $@ $^


%.obj: %.c
	$(WINCC) $(UMAKEDEPS) $(WINCFLAGS) -c -o $@ $<
%.i: %.c
	$(WINCC) $(UMAKEDEPS) $(WINCFLAGS) -E -o $@ $<
%.s: %.c
	$(WINCC) $(UMAKEDEPS) $(WINCFLAGS) -S -o $@ $<
%.res: %.rc
	$(WINDRES) -O COFF $< $@

-include .*.d

=== debian/changelog ===
syslinux (3:6.04~git20190206.bf6db5b4+dfsg1-3.2) unstable; urgency=medium

  * Add a very simple smoke autopkgtest that spawns qemu with a syslinux
    image, waiting for the "boot:" prompt.
  * Remove broken debug symbols from syslinux-utils.  (Closes: #1110525)

 -- Philipp Kern <pkern@debian.org>  Mon, 11 Aug 2025 22:22:57 +0200

syslinux (3:6.04~git20190206.bf6db5b4+dfsg1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add GCC 14 compatibility patch. Thanks to Marek Benc.
    (Closes: #1091027, #1057462)
  * Add wchar_t definition for gnu-efi >= 3.0.16 compatibility.
    (Closes: #994274)
  * Update build dependency on e2fslibs-dev => libext2fs-dev.
  * Update Lintian overrides to match again.

 -- Philipp Kern <pkern@debian.org>  Sun, 13 Apr 2025 11:31:54 +0200

syslinux (3:6.04~git20190206.bf6db5b4+dfsg1-3) unstable; urgency=medium

  * Add patch for compatibility with gcc-10 (Closes: 957858)
  * Update copyright so the correct license is added to com32/gpllib/zzjson/*
  * Update standards version to 4.5.0, no changes needed

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 16 Aug 2020 15:46:13 +0200

syslinux (3:6.04~git20190206.bf6db5b4+dfsg1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Fix day-of-week for changelog entry 1:3.60~pre2-1.
  * Update standards version to 4.4.1, no changes needed.

  [ Lukas Schwaighofer ]
  * Switch build-dependency from python2 to python3. (Closes: 938617)
  * Strip memtest and memcpy from libefi.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Mon, 23 Dec 2019 18:17:06 +0100

syslinux (3:6.04~git20190206.bf6db5b4+dfsg1-1) unstable; urgency=medium

  * Import new version (upstream's git state).
    - Update patches and drop those merged upstream.
    - Adjust debian/copyright for new release.
  * Document the justification of lintian overrides.
  * Override new portable-executable lintian check.
  * Bump Standards-Version to 4.3.0.
  * Prevent optimizing the pow() function. (Closes: #918915)

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Wed, 27 Feb 2019 00:35:07 +0100

=== debian/control ===
Source: syslinux
Section: admin
Priority: optional
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
Build-Depends:
 debhelper-compat (= 12),
 libext2fs-dev,
 gcc-multilib [amd64 x32],
 libc6-dev-i386 [amd64 x32],
 nasm,
 python3,
 uuid-dev,
Build-Depends-Indep: gnu-efi (>= 3.0.8)
Standards-Version: 4.5.0
Homepage: http://www.syslinux.org/
Vcs-Git: https://salsa.debian.org/images-team/syslinux.git
Vcs-Browser: https://salsa.debian.org/images-team/syslinux

Package: syslinux
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
  mtools,
Recommends: syslinux-common
Suggests: dosfstools
Description: collection of bootloaders (DOS FAT and NTFS bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for DOS FAT and NTFS filesystems
 (SYSLINUX).

Package: syslinux-efi
Architecture: all
Multi-Arch: foreign
Built-Using: ${built:Using}
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: dosfstools
Description: collection of bootloaders (UEFI bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for the Unified Extensible Firmware
 Interface (EFI).

Package: extlinux
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: syslinux-common
Description: collection of bootloaders (Linux ext2/ext3/ext4, btrfs, and xfs bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for Linux ext2/ext3/ext4, btrfs, and xfs
 filesystems (EXTLINUX).

Package: isolinux
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: xorriso
Description: collection of bootloaders (ISO 9660 bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for ISO 9660 CD-ROMs (ISOLINUX).

Package: pxelinux
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: syslinux-common
Suggests: tftpd-hpa
Description: collection of bootloaders (PXE network bootloader)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the bootloader for PXE network boots (PXELINUX).

Package: syslinux-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: collection of bootloaders (common)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the common files.

Package: syslinux-utils
Architecture: amd64 i386 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libcrypt-passwdmd5-perl,
 libdigest-sha-perl,
Description: collection of bootloaders (utilities)
 syslinux is a suite of bootloaders, currently supporting DOS FAT and NTFS
 filesystems (SYSLINUX), Linux ext2/ext3/ext4, btrfs, and xfs filesystems
 (EXTLINUX), PXE network boots (PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).
 .
 This package contains the auxiliary utilities.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := sh -e

DATE = $(shell TZ=UTC0 date -d@$(SOURCE_DATE_EPOCH) +%Y%m%d)
HEXDATE = $(shell printf '0x%08x' $(SOURCE_DATE_EPOCH))

# required in patched mk/efi.mk makefile to link against the gnu-efi package
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

unexport LDFLAGS

%:
	dh ${@}

override_dh_auto_build-arch:
	$(MAKE) bios DATE="$(DATE)" HEXDATE="$(HEXDATE)" PYTHON=python3

override_dh_auto_install-arch:
	$(MAKE) bios install INSTALLROOT=$(CURDIR)/debian/tmp

override_dh_auto_build-indep:
	$(MAKE) DATE="$(DATE)" HEXDATE="$(HEXDATE)" PYTHON=python3

override_dh_auto_install-indep:
	$(MAKE) install INSTALLROOT=$(CURDIR)/debian/tmp

override_dh_auto_test:
	# disabled

override_dh_fixperms:
	dh_fixperms
	# the efi files do not exist when building only the arch dependent packages; ignore exit code of chmod
	-chmod 0644 debian/*/usr/lib/*/efi*/*
	-chmod 0644 debian/*/usr/lib/*/modules/efi*/*

override_dh_install:
	# put documentation files into debian/tmp, organize them in a suitable way
	mkdir -p debian/tmp/usr/share/doc/syslinux-common
	cp -aL README debian/tmp/usr/share/doc/syslinux-common/README.txt
	cp -aL doc debian/tmp/usr/share/doc/syslinux-common/txt
	cp -aL txt debian/tmp/usr/share/doc/syslinux-common/asciidoc
	# rename the package specific documentation files
	mv debian/tmp/usr/share/doc/syslinux-common/txt/logo debian/tmp/usr/share/doc/syslinux-common
	set -e ; \
		for docdir in syslinux extlinux isolinux pxelinux ; do \
		mkdir -p debian/tmp/usr/share/doc/$${docdir} ; \
		mv debian/tmp/usr/share/doc/syslinux-common/txt/$${docdir}.txt debian/tmp/usr/share/doc/$${docdir}/README.txt ; \
		done
	# keytab-lilo is not installed as it's part of the lilo package, also
	# exclude the documentation from being installed
	# separate LICENSE files are not needed, they are covered by
	# debian/copyright
	dh_install -X keytab-lilo.txt -X LICENSE

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# avoid isohybrid.pl.1 man page to be interpreted as Polish
override_dh_installman:
	dh_installman --language=C

override_dh_gencontrol-indep:
	dh_gencontrol -- -Vbuilt:Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W gnu-efi)"

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_dwz:
	# debug files do not work for this package

=== debian/tests/control ===
Tests: smoke
Depends: syslinux, qemu-system-x86, expect, coreutils, dosfstools
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1,repack,compression=xz" \
	https://www.kernel.org/pub/linux/utils/boot/syslinux/ syslinux-@ANY_VERSION@@ARCHIVE_EXT@
